var ElementsGUIMain = new function(){
//GetVariable
 /**
 * Файл с общими графическими элементами
 * Отображение ошибок
 * Сканнер
 * Настройки
 * Авторизация
 * Большие попапы, с PTZ и без
 */
//var COFH = IR.ProjectScaleHeight; 	    //Коэфициент скалирования по высоте	    //Коэфициент скалирования по высоте
var MAXLISTSIZE = 650;//Максимальный размер листа в планшетном попапе с учетом коэфицента скалирования
var ITEMSIZE = 88;//Рзмер элемента списка с учетом коэфицента скалирования
var that = this;
this.PF = IR.DisplayType === IR.DISPLAY_TYPE_TABLET ? "" : ":phone"; //Постфикс попапов в зависимости от режима работы(телефон/планшет)
var post = IR.DisplayType != IR.DISPLAY_TYPE_TABLET? ":phone": "";//Тип устройства
var l_oOnfHome = IR.GetPage("Home"+post);

//Большой попап-----------------------------------------------------------
var BigPopup = IR.GetPopup("BigPopup");
BigPopup.BtnBack = BigPopup.GetItem("BtnBack");
BigPopup.Panel = BigPopup.GetItem("Panel");
BigPopup.Panel.GetState(0).ImageStretch = 2;

function hideBigPopup()
{
    IR.HidePopup(BigPopup.Name);
    BigPopup.Panel.GetState(0).Image = "";
}

IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPopup.BtnBack, hideBigPopup);
IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPopup.Panel, hideBigPopup);

this.ShowBigPopup = function (in_oImage)
{
    if(that.PF === "")
    {
        BigPopup.Panel.GetState(0).Image = in_oImage;
        IR.ShowPopup(BigPopup.Name);
    }
};
////Большой попап-----------------------------------------------------------

//Попапы и их элементы
var Scanner = IR.GetPopup("Scanner" + this.PF);
Scanner.List = Scanner.GetItem("LstCams");
Scanner.Loading = Scanner.GetItem("Loading");
Scanner.Footer = Scanner.GetItem("Footer");
Scanner.No = Scanner.GetItem("NO");
this.Scanner = Scanner;


//Сделаем попап сканера, попапом настроек
//С помощъю него будут добавлятся кмеры
IR.SettingsPopupName = this.Scanner.Name;


var Settings = IR.GetPopup("Settings" + this.PF);
Settings.List = Settings.GetItem("LstSettings");
Settings.Loading = Settings.GetItem("Loading");
Settings.BtnBack = Settings.GetItem("BtnBack");
Settings.Footer = Settings.GetItem("Footer");
Settings.No = Settings.GetItem("No");
Settings.Loading.Visible = false;

//По старту обновим переменные и заполним лист
    COFH = IR.ProjectScaleHeight; 	    //Коэфициент скалирования по высоте
    MAXLISTSIZE = 650 / COFH;     //Максимальный размер листа в планшетном попапе с учетом коэфицента скалирования
    ITEMSIZE = 88 / COFH;         //Рзмер элемента списка с учетом коэфицента скалирования
    that.PF = IR.DisplayType === IR.DISPLAY_TYPE_TABLET ? "" : ":phone"; //Постфикс попапов в зависимости от режима работы(телефон/планшет)

    Settings.List.AddItem("TplSettings"+post, {
        LblName: {
            Text: "PTZ"
        },
        LblDescription: {
            Text: "PTZ"
        }
    }, 1, 1, 1);
   Settings.List.AddItem("TplSettings"+post, {
        LblName: {
            Text: "Delete"
        },
        LblDescription: {
            Text: "Delete"
        }
    }, 1, 2, 2);
    resizePopup(Settings);



var l_oCurrentCamera;

//Функция показа попапа настроек, один для всех камер
this.ShowSettingsPopup = function (in_oCamera) {
    l_oCurrentCamera = in_oCamera;
    IR.ShowPopup(Settings.Name);

    addSettingsListeners(in_oCamera);

    if (in_oCamera.l_bPTZSupport == true) {
        Settings.List.GetItemByIndex(0).Popup.GetItem("LblDescription").Text = "Support";
        Settings.List.GetItemByIndex(0).Popup.GetItem("TrgSelect").Visible = true;
        Settings.List.GetItemByIndex(0).Popup.GetItem("panel secondary").Hit = 0;
    }
    else {
        Settings.List.GetItemByIndex(0).Popup.GetItem("LblDescription").Text = "No support";
        Settings.List.GetItemByIndex(0).Popup.GetItem("TrgSelect").Visible = false;
        Settings.List.GetItemByIndex(0).Popup.GetItem("panel secondary").Hit = 2;
    }
};
function addSettingsListeners(in_oCamera) {
    IR.AddListener(IR.EVENT_LIST_ITEM_CHANGE, Settings.List, selectSettingsParse, { oCamera: in_oCamera });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, Settings.BtnBack, function () { IR.HidePopup(Settings.Name); removeSettingsListeners(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, that.Auth.BtnCancel, that.Auth.Cancel, { oPopup: Settings });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, that.Auth.BtnDone, that.Auth.Done, { oPopup: Settings, oCamera: in_oCamera });
}
function removeSettingsListeners() {
    IR.RemoveListener(IR.EVENT_LIST_ITEM_CHANGE, Settings.List, selectSettingsParse);
    IR.RemoveListener(IR.EVENT_ITEM_RELEASE, Settings.BtnBack, function () { IR.HidePopup(Settings.Name); removeSettingsListeners(); });
    IR.RemoveListener(IR.EVENT_ITEM_RELEASE, that.Auth.BtnCancel, that.Auth.Cancel);
    IR.RemoveListener(IR.EVENT_ITEM_RELEASE, that.Auth.BtnDone, that.Auth.Done);
}
//Попап-c-PTZ------------------------------------------------------------------------------------------------------------
var BigPtzPopup = IR.GetPopup("BigPopupPTZ" + that.PF);
    BigPtzPopup.BtnBack = BigPtzPopup.GetItem("BtnBack");

    BigPtzPopup.Panel = BigPtzPopup.GetItem("Panel");
    BigPtzPopup.Panel.GetState(0).ImageStretch = 2;

    BigPtzPopup.BtnTop = BigPtzPopup.GetItem("Top");
    BigPtzPopup.BtnTLeft = BigPtzPopup.GetItem("TLeft");
    BigPtzPopup.BtnTRight = BigPtzPopup.GetItem("TRight");
    BigPtzPopup.BtnLeft = BigPtzPopup.GetItem("Left");
    BigPtzPopup.BtnRight = BigPtzPopup.GetItem("Right");
    BigPtzPopup.BtnBot = BigPtzPopup.GetItem("Bot");
    BigPtzPopup.BtnBLeft = BigPtzPopup.GetItem("BLeft");
    BigPtzPopup.BtnBRight = BigPtzPopup.GetItem("BRight");
    BigPtzPopup.BtnRotate = BigPtzPopup.GetItem("Center");

    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnBack,  function () { IR.HidePopup(BigPtzPopup.Name); });

    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnTop,  function ()    { l_oCurrentCamera.PTZControl.Top();      });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnTLeft,  function ()  { l_oCurrentCamera.PTZControl.TopLeft();  });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnTRight,  function () { l_oCurrentCamera.PTZControl.TopRight(); });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnLeft,  function ()   { l_oCurrentCamera.PTZControl.Left();     });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnRight,  function ()  { l_oCurrentCamera.PTZControl.Right();    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnBot,  function ()    { l_oCurrentCamera.PTZControl.Bot();      });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnBLeft,  function ()  { l_oCurrentCamera.PTZControl.BotLeft();  });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnBRight,  function () { l_oCurrentCamera.PTZControl.BotRight(); });
    IR.AddListener(IR.EVENT_ITEM_PRESS, BigPtzPopup.BtnRotate,  function () { l_oCurrentCamera.PTZControl.Zoom();   });

    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnTop,  function ()   { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnTLeft,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnTRight,  function (){ l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnLeft,  function ()  { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnRight,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnBot,  function ()   { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnBLeft,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnBRight,  function (){ l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_END_HOLD, BigPtzPopup.BtnRotate,  function (){ l_oCurrentCamera.PTZControl.Stop(); });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnTop,  function ()   { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnTLeft,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnTRight,  function (){ l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnLeft,  function ()  { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnRight,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnBot,  function ()   { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnBLeft,  function () { l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnBRight,  function (){ l_oCurrentCamera.PTZControl.Stop(); });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, BigPtzPopup.BtnRotate,  function (){ l_oCurrentCamera.PTZControl.Stop(); });

////Попап-c-PTZ------------------------------------------------------------------------------------------------------------
function selectSettingsParse(in_nItem, Subitem, in_nTypeEvent, in_oObject) {
    if (in_nTypeEvent == IR.EVENT_LIST_ITEM_RELEASE) {
        var l_oSitem = Settings.List.GetItemByIndex(in_nItem).Popup.GetItem("LblName").Text;
        switch (l_oSitem) {
            case "Authorization":
               // that.Auth.Open(Settings, this.oCamera);
                break;
            case "PTZ":
                    if(this.oCamera.l_bPTZSupport == true)
                    {
                        IR.ShowPopup(BigPtzPopup.Name);
                        BigPtzPopup.Panel.GetState(0).Image = this.oCamera.ImageUrl;
                    }
                break;
            case "Delete":
            var names = l_oOnfHome.GetItem("List").GetItemByIndex(selectItemListSettings).Popup.GetItem("Names").Text;
            l_oAddedCams2[names].deletingClone();
            l_oAddedCams2[names].deletingClone(IR.GetDevice(IR.GetDevice(names.replace(/\./g,""))));
            IR.DeleteDevice(IR.GetDevice(names.replace(/\./g,"")));
            delete l_oJSONAddedCams[names];
            delete l_oJSONAddedCams2[names]
            delete l_oAddedCams[names];
            delete l_oAddedCams2[names];
            
            IR.SetVariable("Global.Cameras", JSON.Stringify(l_oJSONAddedCams));
            l_oOnfHome.GetItem("List").DeleteItemByIndex(selectItemListSettings);
            IR.HidePopup(Settings.Name);
            removeSettingsListeners();
            
            return
                break;
        }
    }
}

    function fRemovedSubDevice(in_oDevice)
    {
        in_oDevice.DeleteTag("SetImage", [0x00, 0x00, 0x00, 0x00]);
        in_oDevice.DeleteTag("StateConnected", [0x00, 0x00, 0x00, 0x00]);
        in_oDevice.DeleteTag("StateAuth", [0x00, 0x00, 0x00, 0x00]);
        in_oDevice.DeleteTag("StateLoading", [0x00, 0x00, 0x00, 0x00]);
        in_oDevice.DeleteTag("PTZSupport", [0x00, 0x00, 0x00, 0x00]);
        in_oDevice.DeleteTag("ShowPopup", [0x00, 0x00, 0x00, 0x00]);
        IR.RemoveListener(IR.EVENT_CHANNEL_SET, HTTPDriver, fChannelSet);
    }

this.Auth = IR.GetPopup("AuthPopup" + this.PF);
this.Auth.BtnCancel = this.Auth.GetItem("BtnCancel");
this.Auth.BtnDone = this.Auth.GetItem("BtnDone");
this.Auth.BtnLogin = this.Auth.GetItem("BtnLogin");
this.Auth.BtnPassword = this.Auth.GetItem("BtnPassword");
this.Auth.LblLogin = this.Auth.GetItem("LblLogin");
this.Auth.EdtPassword = this.Auth.GetItem("EdtPassword");

var Error = IR.GetPopup("Error" + this.PF);
Error.BtnOk = Error.GetItem("BtnOk");
Error.Caption = Error.GetItem("Caption");

this.ShowError = function (in_sText, in_fAfterOk) {
    Error.Caption.Text = in_sText;
    IR.ShowPopup(Error.Name);

    IR.AddListener(IR.EVENT_ITEM_RELEASE, Error.BtnOk, function () {
        IR.HidePopup(Error.Name);
        if (this.Callback !== void 0) {
            this.Callback();
        }
    }, { Callback: in_fAfterOk });

};


this.Edit = IR.GetPopup("Edit" + this.PF);
this.Edit.BtnCancel = this.Edit.GetItem("BtnCancel");
this.Edit.BtnOk = this.Edit.GetItem("BtnOk");
this.Edit.EdtEdit = this.Edit.GetItem("Edit");
this.Edit.Caption = this.Edit.GetItem("Caption");

this.Scanner.BtnBack = this.Scanner.GetItem("BtnBack");



this.Auth.Open = function (in_oPopup, in_oCamera) {
    IR.ShowPopup(that.Auth.Name);
    if (in_oCamera === void 0) {
        that.Auth.LblLogin.Text = "";
        that.Auth.EdtPassword.Text = "";
    } else {
        that.Auth.LblLogin.Text = in_oCamera.GetLogin();
        that.Auth.EdtPassword.Text = in_oCamera.GetPassword();
    }
    that.Auth.EdtPassword.PasswordChar = "*";
    IR.HidePopup(in_oPopup.Name);
};
this.Auth.Cancel = function (in_oPopup) {
    var l_oPopup = in_oPopup;
    if (l_oPopup === void 0)
        l_oPopup = this.oPopup;
        
    IR.ShowPopup(l_oPopup.Name);
    IR.HidePopup(that.Auth.Name);
};
this.Edit.OpenLogin = function () {
    IR.ShowKeyboard(1);
    IR.ShowPopup(that.Edit.Name);
    that.Edit.EdtEdit.Text = that.Auth.LblLogin.Text;
    that.Edit.Caption.Text = "Login";
    that.Edit.EdtEdit.PasswordChar = "";
    IR.HidePopup(that.Auth.Name);
};
this.Edit.OpenPassword = function () {
    IR.ShowKeyboard(1);
    IR.ShowPopup(that.Edit.Name);
    that.Edit.EdtEdit.Text = that.Auth.EdtPassword.Text;
    that.Edit.Caption.Text = "Password";
    that.Edit.EdtEdit.PasswordChar = "*";
    IR.HidePopup(that.Auth.Name);
};
this.Edit.Cancel = function () {
    IR.ShowPopup(that.Auth.Name);
    IR.HidePopup(that.Edit.Name);
};
this.Auth.Done = function (in_oFindedCam, in_oPopup) {
    var l_oPopup = in_oPopup;
    var isCallofScanner = true;
    if (in_oPopup === void 0) {
        l_oPopup = this.oPopup;
        isCallofScanner = false;
    }
    IR.ShowPopup(l_oPopup.Name);
    IR.HidePopup(that.Auth.Name);
    if (isCallofScanner === true) {
        in_oFindedCam.Login = that.Auth.LblLogin.Text;
        in_oFindedCam.Password = that.Auth.EdtPassword.Text;
        return in_oFindedCam;
    } else {
        var isChanged = false;
        var in_oCamera = this.oCamera;
        if (in_oCamera.GetPassword() != that.Auth.EdtPassword.Text) {
            isChanged = true;
            in_oCamera.SetPassword(that.Auth.EdtPassword.Text)
        }
        if (in_oCamera.GetLogin() != that.Auth.LblLogin.Text) {
            isChanged = true;
            in_oCamera.SetLogin(that.Auth.LblLogin.Text)
        }
        if (isChanged === true)
            in_oCamera.SyncTime();
    }
};
this.Edit.Ok = function () {
    if (that.Edit.Caption.Text == "Login") {
        that.Auth.LblLogin.Text = that.Edit.EdtEdit.Text;
    } else {
        that.Auth.EdtPassword.Text = that.Edit.EdtEdit.Text;
    }
    IR.ShowPopup(that.Auth.Name);
    IR.HidePopup(that.Edit.Name);
};

this.Scanner.Flush = function () {
    Scanner.List.Clear();
    Scanner.Loading.Visible = true;
    resizePopup(Scanner, 1)
};

this.AddScannerItem = function (in_oCamItem, in_bEnable) {
    Scanner.Loading.Visible = false;
    Scanner.List.AddItem("TplScannerDevice"+post, {
        TrgSelect: {
            Visible: in_bEnable
        },
        LblName: {
            Text: in_bEnable ? in_oCamItem.Name : "(already exist) " + in_oCamItem.Name
        },
        LblDescription: {
            Text: in_oCamItem.Hardware + " - " + in_oCamItem.Adress
        },
        Loading: {
            Visible: false
        },
        UUID: {
            Text: in_bEnable ? in_oCamItem.UAdress : "1"
        }
    }, in_oCamItem.Name, 1, in_oCamItem.Name);
    resizePopup(Scanner);
};

function resizePopup(in_oPopup, in_Count) {
    if (in_Count === void 0)
        var in_Count = in_oPopup.List.ItemsCount;
    if (that.PF == "") {
        var l_nListHeight = ITEMSIZE;

        if (in_Count < 6) {
            var l_nListHeight = ITEMSIZE * in_Count;
        } else {
            var l_nListHeight = MAXLISTSIZE;
        }

        in_oPopup.List.Height = l_nListHeight;
        in_oPopup.Footer.Y = l_nListHeight + in_oPopup.List.Y;
    }
}
}