/**
 * Объект графической части камеры
 * на входе имя для сабдевайса и попапа @param in_sName
 * имя для заголовка виджета @param in_sHardware
 * @constructor
 */
var post = IR.DisplayType != IR.DISPLAY_TYPE_TABLET? ":phone": "";//Тип устройства
var l_oOnfHome = IR.GetPage("Home"+post);
var i_oList = l_oOnfHome.GetItem("List"); 
i_oList.Template = "Cam"+post;//Присвоили шаблон списка
l_oOnfHome.GetItem("Icon").GetState(0).ImageStretch = 2;
   var selectItemListSettings; 
   IR.AddListener(IR.EVENT_ITEM_SELECT, i_oList, selectItem);
   
   function selectItem(in_oItem, in_oSubItem, id){
      selectItemListSettings=id;
    }

GuiCam = function (in_sName, in_sHardware) {

    var that = this;
    var G = ElementsGUIMain;
    var NAME = in_sName.replace(/\./g,"");
    l_oJSONAddedCams2[in_sName] = JSON.Parse(IR.GetVariable("Global.Cameras"))[in_sName];
    
   var List =  i_oList;
   var l_oClone = List.AddItem(List.Template);
   l_oClone.Popup.GetItem("LblCaption").Text = in_sHardware;//in_sHardware;
   l_oClone.Popup.GetItem("Names").Text = in_sName;//in_sHardware;
   
   IR.AddListener(IR.EVENT_TAG_CHANGE, IR.GetDevice(in_sName.replace(/\./g,"")), l_fTagProcessing, this);
              

   this.l_bPTZSupport = false;
   this.ImageUrl = false;
     
    IR.AddListener(IR.EVENT_ITEM_RELEASE, l_oClone.Popup.GetItem("BtnSettings"), fBtnSettings = function () {
        G.ShowSettingsPopup(that);
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, l_oClone.Popup.GetItem("BtnBigPopup"), fBtnBigPopup = function () {
        G.ShowBigPopup(l_oClone.Popup.GetItem("Panel").GetState(0).Image);
    });

    var l_oSubDevice = IR.GetDevice(in_sName.replace(/\./g,""));
    this.PTZControl = {
    
        Zoom: function ()
        {
            l_oSubDevice.Set("PTZ", "Zoom");
        },
        Top: function ()
        {
            l_oSubDevice.Set("PTZ", "Top");
        },
        TopLeft: function ()
        {
            l_oSubDevice.Set("PTZ", "TopLeft");
        },
        TopRight: function ()
        {
            l_oSubDevice.Set("PTZ", "TopRight");
        },
        Left: function ()
        {
            l_oSubDevice.Set("PTZ", "Left");
        },
        Right: function ()
        {
            l_oSubDevice.Set("PTZ", "Right");
        },
        Bot: function ()
        {
            l_oSubDevice.Set("PTZ", "Bot");
        },
        BotLeft: function ()
        {
            l_oSubDevice.Set("PTZ", "BotLeft");
        },
        BotRight: function ()
        {
            l_oSubDevice.Set("PTZ", "BotRight");
        },
        Stop: function ()
        {
            l_oSubDevice.Set("PTZ", "Stop");
        }
    };

    function imageError()
    {
        l_oSubDevice.SetFeedback("StateAuth", false)
    }
    
    function l_fTagProcessing(in_sTag, in_sValue) {
        switch (in_sTag) {
            case "SetImage":
                  that.ImageUrl = in_sValue;
                  /*
                  l_oClone.Popup.GetItem("Panel").GetState(0).Image = in_sValue;
                  l_oClone.Popup.GetItem("Panel").GetState(0).ImageStretch = 2;
                  */

                 IR.CreateImage(in_sValue, {URI: in_sValue
                 });
                                        
                 var l_oImage = IR.GetImage(in_sValue); 
                 IR.AddListener(IR.EVENT_ONLINE, l_oImage, function(){
                    l_oClone.Popup.GetItem("CoverTextC").Visible = false;
                    l_oClone.Popup.GetItem("CoverTextC").Visible = false;
                    l_oClone.Popup.GetItem("CoverC").Visible = false;
                    l_oClone.Popup.GetItem("CoverC").Visible = false;
                 });
            
                 IR.AddListener(IR.EVENT_OFFLINE, l_oImage, function(){
                    l_oClone.Popup.GetItem("CoverTextC").Visible = true;
                    l_oClone.Popup.GetItem("CoverTextC").Visible = true;
                    l_oClone.Popup.GetItem("CoverC").Visible = true;
                    l_oClone.Popup.GetItem("CoverC").Visible = true;
                 });
                
                 IR.AddListener(IR.EVENT_ERROR, l_oImage, function(in_error){
                    l_oClone.Popup.GetItem("CoverTextC").Visible = true;
                    l_oClone.Popup.GetItem("CoverTextC").Visible = true;
                    l_oClone.Popup.GetItem("CoverC").Visible = true;
                    l_oClone.Popup.GetItem("CoverC").Visible = true;
                 });

                 l_oClone.Popup.GetItem("Panel").GetState(0).Image = l_oImage;
                 l_oClone.Popup.GetItem("Panel").GetState(0).ImageStretch = 2;
                  break;
            case "StateConnected":
                l_oClone.Popup.GetItem("CoverTextC").Visible = !in_sValue;
                l_oClone.Popup.GetItem("CoverTextC").Visible = !in_sValue;
                l_oClone.Popup.GetItem("CoverC").Visible = !in_sValue;
                l_oClone.Popup.GetItem("CoverC").Visible = !in_sValue;
                break;
            case "StateAuth":
                l_oClone.Popup.GetItem("CoverTextA").Visible = !in_sValue;
                l_oClone.Popup.GetItem("CoverTextA").Visible = !in_sValue;
               l_oClone.Popup.GetItem("CoverA").Visible = !in_sValue;
                l_oClone.Popup.GetItem("CoverA").Visible = !in_sValue;
                break;
            case "StateLoading":
                l_oClone.Popup.GetItem("Loading").Visible = in_sValue;
                break;
            case "PTZSupport":
                that.l_bPTZSupport = in_sValue;
                break;
            case "ShowPopup":
                try
                {
                    if(in_sValue.split(":")[0] == "Show")
                        G.ShowBigPopup(l_oClone.GetItem("Panel").GetState(0).Image);
                }catch(err)
                {
                }
                break;
        }
    }



    IR.AddListener(IR.EVENT_WILL_BE_REMOVED_SUBDEVICE, 0, deletingClone);

   function deletingClone(in_oDevice) {

            IR.RemoveListener(IR.EVENT_ITEM_RELEASE, l_oClone.BtnSettings, fBtnSettings);
            IR.RemoveListener(IR.EVENT_ITEM_RELEASE, l_oClone.BtnBigPopup, fBtnBigPopup);
            IR.RemoveListener(IR.EVENT_TAG_CHANGE, l_oSubDevice, l_fTagProcessing);
    }
    this.deletingClone = deletingClone;
};
var SOAP = new MYSOAP();