/**
 * Файл графической части сканера
 */

	var G = ElementsGUIMain;
	var ScannerDevice = IR.GetDevice("OnvifUDP");
    var l_sCams = IR.GetVariable("Global.Cameras");

    var Scanner = {};
    var l_oScannedCams = {};
    var l_oSubDevice = {};
    var l_sSelectedCam = "";

	//При открытии попапа сканера
var post = IR.DisplayType != IR.DISPLAY_TYPE_TABLET? ":phone": "";//Тип устройства
var Popup_add_Device = IR.GetPopup("Scanner"+post);//Попап добавить сабдевайс
var Home = IR.GetPage("Home"+post);//Домашняя страница

IR.AddListener(IR.EVENT_ITEM_RELEASE, Home.GetItem("BtnAdd"), function(){
IR.ShowPopup("Scanner"+post);
});

IR.AddListener(IR.EVENT_ITEM_SHOW, G.Scanner, function(){
      removeListeners();
      G.Scanner.Flush();
		Scanner = new OnvifScanner(ScannerDevice, OnReceiveNewCam, l_oScannedCams);
		Scanner.Start();
		addListeners();
	});
    
	//При закрытии попапа сканера
	IR.AddListener(IR.EVENT_ITEM_HIDE, G.Scanner, function()
	{  
		Scanner.Stop();
		delete Scanner;
      }); 

	//Выход из сканера
	IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Scanner.BtnBack, function()
	{	
      IR.HidePopup(G.Scanner.Name);
		removeListeners();
	});

	//По нажатию на добавление камеры
 	IR.AddListener(IR.EVENT_ITEM_SELECT, G.Scanner.List, 
	function(in_nItem, in_nSubitem, id) 
	{ 	
			l_sSelectedCam = G.Scanner.List.GetItemByIndex(id).Popup.GetItem("UUID").Text;
			if(l_sSelectedCam !== "1")
			G.Auth.Open(G.Scanner);
	});

 	//Добавление камеры
	function fAfterBtnDone()
	{   
        l_oScannedCams[l_sSelectedCam].Login = G.Auth.LblLogin.Text;
        l_oScannedCams[l_sSelectedCam].Password = G.Auth.EdtPassword.Text;
      IR.HidePopup(G.Auth.Name);
       IR.HidePopup(G.Scanner.Name);
        //http://192168093/onvif/device_service удаляем точки, для , того, что бы можно было устанавливать связи по имени   CreateAndSaveDevice
	    var l_sGoodName = l_oScannedCams[l_sSelectedCam].UAdress.replace(/\./g,"");
       var l_oAddedCamsTemp = JSON.Parse(IR.GetVariable("Global.Cameras"));
		 l_oAddedCams[l_sSelectedCam] = l_oScannedCams[l_sSelectedCam];
       if(!l_oAddedCamsTemp){l_oAddedCamsTemp = {};}
       l_oAddedCamsTemp[l_oScannedCams[l_sSelectedCam]["UAdress"]] = l_oScannedCams[l_sSelectedCam];
      IR.SetVariable("Global.Cameras",JSON.Stringify(l_oAddedCamsTemp));
        //ScannerDevice.SetFeedback("UpdateCams", "created");
        UpdateCameras1();
	}


	//При очередной найденой камере
	function OnReceiveNewCam(in_oNewOnvifCam)
	{
		var l_bAbsent = true;
		if(l_oAddedCams[in_oNewOnvifCam.UAdress])
		{
			l_bAbsent = false;
		}
		G.AddScannerItem(in_oNewOnvifCam, l_bAbsent);
	}

IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnLogin, G.Edit.OpenLogin);
IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnPassword, G.Edit.OpenPassword);
IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Edit.BtnCancel, G.Edit.Cancel);
IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Edit.BtnOk, G.Edit.Ok);
	
   function addListeners()
	{
		IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnCancel, G.Auth.Cancel, {oPopup: G.Scanner});
		IR.AddListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnDone, fAfterBtnDone, {oPopup: G.Scanner});
	}
	function removeListeners()
	{
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnCancel, G.Auth.Cancel);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, G.Auth.BtnDone, fAfterBtnDone);
	}



